#  -*- coding: cp1252 german encoding -*-
"""Adapt scheme

Revision ID: f3e1d7e152c4
Revises: 
Create Date: 2018-09-06 07:36:54.683000

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'f3e1d7e152c4'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    # op.drop_table('sqlite_sequence')

    # UPDATE wallet first
    query0 = u"""
    UPDATE wallet
    SET wallet_type_id = ( SELECT desc
                           FROM wallet_type
                           WHERE wallet.wallet_type_id = wallet_type.id )
    WHERE EXISTS ( SELECT desc
                   FROM wallet_type
                   WHERE wallet.wallet_type_id = wallet_type.id )
    """
    op.get_bind().execute(query0)

    query1 = u"""
    UPDATE rule_split
    SET contains="AachenMünchener Versicherung AG"
    WHERE id=2
    """
    op.get_bind().execute(query1)

    query2 = u"""
    UPDATE rule_split
    SET contains="AachenMünchener Lebensversicherung AG"
    WHERE id=1
    """
    op.get_bind().execute(query2)


    op.drop_table('wallet_type')
    with op.batch_alter_table('category') as batch_op:
        batch_op.create_unique_constraint('category_unique', ['name'])
        batch_op.create_foreign_key(batch_op.f('fk_category_parent_id_category'), 'category', ['parent_id'], ['id'])

    with op.batch_alter_table('rule_category') as batch_op:
        batch_op.create_unique_constraint(batch_op.f('uq_rule_category_cond_field'), ['cond_field', 'contains'])
        batch_op.create_foreign_key(batch_op.f('fk_rule_category_category_id_category'), 'category', ['category_id'],
                                    ['id'])

    with op.batch_alter_table('transaction') as batch_op:
        batch_op.create_unique_constraint(batch_op.f('uq_transaction_uniqueid'), ['uniqueid'])
        batch_op.create_foreign_key(batch_op.f('fk_transaction_wallet_id_wallet'), 'wallet', ['wallet_id'], ['id'])
        batch_op.create_foreign_key(batch_op.f('fk_transaction_category_id_category'), 'category', ['category_id'],
                                    ['id'])

    with op.batch_alter_table('wallet') as batch_op:
        batch_op.alter_column('as_p_regex', new_column_name='as_format_info')
        batch_op.alter_column('wallet_type_id', new_column_name='type', type=sa.Enum('Cash', 'Giro', 'Credit Card', 'Fonds', 'Building society savings', 'Annuity insurance', 'Prepaid', 'Miscellaneous'))
        batch_op.alter_column('consider', new_column_name='fast_accessible')
        batch_op.alter_column('desc',  new_column_name='name')
        batch_op.create_unique_constraint(batch_op.f('uq_wallet_name'), ['name'])

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    with op.batch_alter_table('wallet') as batch_op:
        batch_op.drop_constraint(batch_op.f('uq_wallet_name'), type_='unique')
        batch_op.alter_column('as_format_info', new_column_name='as_p_regex')
        batch_op.alter_column('wallet_type', new_column_name='wallet_type_id', type=sa.Integer)
        batch_op.alter_column('fast_accessible', new_column_name='consider')
        batch_op.alter_column('name',  new_column_name='desc')

    with op.batch_alter_table('transaction', schema=None) as batch_op:
        batch_op.drop_constraint(batch_op.f('fk_transaction_category_id_category'), type_='foreignkey')
        batch_op.drop_constraint(batch_op.f('fk_transaction_wallet_id_wallet'), type_='foreignkey')
        batch_op.drop_constraint(batch_op.f('uq_transaction_uniqueid'), type_='unique')

    with op.batch_alter_table('rule_split', schema=None) as batch_op:
        batch_op.drop_constraint(batch_op.f('uq_rule_split_cond_field'), type_='unique')

    with op.batch_alter_table('rule_category', schema=None) as batch_op:
        batch_op.drop_constraint(batch_op.f('fk_rule_category_category_id_category'), type_='foreignkey')
        batch_op.drop_constraint(batch_op.f('uq_rule_category_cond_field'), type_='unique')

    with op.batch_alter_table('category', schema=None) as batch_op:
        batch_op.drop_constraint(batch_op.f('fk_category_parent_id_category'), type_='foreignkey')
        batch_op.drop_constraint(batch_op.f('uq_category_name'), type_='unique')

    # ### end Alembic commands ###
